Strict
Graphics 640,480,0,75

SetMaskColor 255,0,255
Global spr_block:timage=LoadAnimImage("gfx/block.png",26,26,0,3)
Global bg:timage=LoadImage("gfx/bg.bmp")
SeedRnd MilliSecs()

Global score
Global level
Global lines
Global map[18,26]
Global size=26
Global mapx=-22
Global mapy=-90
Global blockx=7
Global blocky=0
Global blockspeed[21]
Global cooldown=75
Global canmove
Global newblock
Global wantrotation

For Local i=0 To 20
	blockspeed[i]=30-i
Next

Global number=Int(Rnd(7))
Global rotation=0
Global blocks[7,4,5,5]
Global nextnumber=Int(Rnd(7))

'read blocks
Local file:TStream=ReadFile("block/blocks.txt")
	For Local j=0 To 4
		For Local i=0 To 4
			blocks[0,0,i,j]=ReadInt(file)
			blocks[0,1,i,j]=ReadInt(file)
			blocks[0,2,i,j]=ReadInt(file)
			blocks[0,3,i,j]=ReadInt(file)
			blocks[1,0,i,j]=ReadInt(file)
			blocks[1,1,i,j]=ReadInt(file)
			blocks[1,2,i,j]=ReadInt(file)
			blocks[1,3,i,j]=ReadInt(file)
			blocks[2,0,i,j]=ReadInt(file)
			blocks[2,1,i,j]=ReadInt(file)
			blocks[2,2,i,j]=ReadInt(file)
			blocks[2,3,i,j]=ReadInt(file)
			blocks[3,0,i,j]=ReadInt(file)
			blocks[3,1,i,j]=ReadInt(file)
			blocks[3,2,i,j]=ReadInt(file)
			blocks[3,3,i,j]=ReadInt(file)
			blocks[4,0,i,j]=ReadInt(file)
			blocks[4,1,i,j]=ReadInt(file)
			blocks[4,2,i,j]=ReadInt(file)
			blocks[4,3,i,j]=ReadInt(file)
			blocks[5,0,i,j]=ReadInt(file)
			blocks[5,1,i,j]=ReadInt(file)
			blocks[5,2,i,j]=ReadInt(file)
			blocks[5,3,i,j]=ReadInt(file)
			blocks[6,0,i,j]=ReadInt(file)
			blocks[6,1,i,j]=ReadInt(file)
			blocks[6,2,i,j]=ReadInt(file)
			blocks[6,3,i,j]=ReadInt(file)
		Next
	Next
CloseFile(file)

'fill map
For Local j=0 To 25
	For Local i=0 To 17
		If i<4 Or i>13 Or j>21
			map[i,j]=2
		Else 
			map[i,j]=0
		EndIf
	Next
Next

'main loop
Repeat
	Cls
	f_game()
	Flip
Until KeyHit(key_escape) Or AppTerminate()

Function f_game()
	DrawImage bg,0,0
	
	'draw map
	For Local j=0 To 25
		For Local i=0 To 17
			If map[i,j]=1 DrawImage spr_block,mapx+i*size,mapy+j*size,1
			If map[i,j]=3 DrawImage spr_block,mapx+i*size,mapy+j*size,2
		Next
	Next
	
	'control block
	If canmove>0 canmove:-1
	
	If KeyDown(key_left) And canmove=0 And f_free(-1,0,rotation)
		blockx:-1
		canmove=10
	EndIf
	If KeyDown(key_right) And canmove=0 And f_free(1,0,rotation)
		blockx:+1
		canmove=10
	EndIf
	If KeyHit(key_up)
		wantrotation=rotation
		If rotation<3 wantrotation:+1 Else wantrotation=0
		If f_free(0,0,wantrotation) rotation=wantrotation
	EndIf
	If KeyHit(key_down)
		wantrotation=rotation
		If rotation>0 wantrotation:-1 Else wantrotation=3
		If f_free(0,0,wantrotation) rotation=wantrotation
	EndIf
	
	'move block
	If cooldown>0 cooldown:-1
	
	If cooldown=0
	
	If f_free(0,1,rotation)=0
		For Local j=0 To 4
			For Local i=0 To 4
				If blocks[number,rotation,i,j]=1
					map[blockx+i,blocky+j]=1
					newblock=1
				EndIf
			Next
		Next
	EndIf
	
		If newblock=1
			blockx=7
			blocky=0
			newblock=0
			number=nextnumber
			nextnumber=Int(Rnd(7))
		EndIf

		blocky:+1
		If KeyDown(key_space) cooldown=5 Else cooldown=blockspeed[level]
		
		'detect full lines (4-21)
		Local fullline[18]
		For Local j=4 To 21
		For Local i=4 To 13
			If map[i,j]=1
				fullline[j-4]:+1
			EndIf
		Next
		Next
				
		For Local j=4 To 21
			If fullline[j-4]=10
				For Local i=4 To 13
					map[i,j]=3
					cooldown=65
				Next
			EndIf
		Next
	EndIf
	
	'change lines
	If cooldown=35
		Local tetris
		For Local r=4 To 21
			If map[4,r]=3
				tetris:+1
				
				For Local l=4 To 13
					map[l,r]=0
				Next
				
				For Local j=r To 4 Step -1
					For Local i=4 To 13
						If map[i,j-1]=1 map[i,j]=1
						map[i,j-1]=0
					Next 
				Next
			EndIf
		Next
		If tetris=1 score:+40*(level+1)
		If tetris=2 score:+100*(level+1)
		If tetris=3 score:+300*(level+1)
		If tetris=4 score:+1200*(level+1)
		lines:+tetris
		If level<20 And lines>=(level+1)*10 level:+1
	EndIf
	
	'draw block
	For Local j=0 To 4
		For Local i=0 To 4
			If blocks[number,rotation,i,j]=1 DrawImage spr_block,mapx+blockx*size+i*size,mapy+blocky*size+j*size,0
		Next
	Next
	
	'gameover
	For Local i=4 To 13
		If map[i,3]=1
			cooldown=-1
			DrawText "< GAMEOVER >",400,320
			If KeyHit(key_enter)
				For Local j=0 To 21
					For Local i=4 To 13
						map[i,j]=0
					Next
				Next
			score=0
			level=0
			lines=0
			cooldown=75
			EndIf
		EndIf
	Next
	
	'display
	DrawText "SCORE: " +score,400,40
	DrawText "LEVEL: " +level,400,80
	DrawText "LINES: " +lines,400,120
	
	For Local j=0 To 4
		For Local i=0 To 4
			If blocks[nextnumber,0,i,j]=1 DrawImage spr_block,380+i*size,180+j*size,0
		Next
	Next
End Function

Function f_free(x,y,nextrotation)
	Local free=1
	For Local j=0 To 4
		For Local i=0 To 4
			If blocks[number,nextrotation,i,j]=1
				If map[blockx+i+x,blocky+j+y]>0 free=0
			EndIf
		Next
	Next
	Return free
End Function